<?php

namespace Teknisa\MAN\Services;

use Doctrine\ORM\EntityManager;
use Teknisa\MAN\Utilities;

class RelDesistenciaProdutoService {

    public function __construct(EntityManager $entityManager) {
        $this->entityManager = $entityManager;
    }
  
    public function find($conditions) {
        $params = array(
            ":CDFILIAL" => implode('_',$conditions['CDFILIAL']),
            ":DTINI" => $conditions['DTENTRVENDA'][0],
            ":DTFIN" => $conditions['DTENTRVENDA'][1],
            ":NRORG" => $conditions['NRORG']
        );
        return $this->entityManager->getConnection()->fetchAll(self::GET_DESIST_PROD, $params);
    }
    
    
    const select  = "
      DECODE(V.DSREFENDCONSVEN, 'VIA AJUSTE FOS', 'Via Ajuste ForSale', '') AS DSAJUSTEFOS, V.IDORIGEMVENDA, DECODE(SUBSTR(V.DSCOMANDAVND,1,3),'PKR',
      V.NRMESA,DECODE(SUBSTR(V.DSCOMANDAVND,1,3),'RES',V.NRMESA,DECODE(SUBSTR(V.DSCOMANDAVND,1,3),'DLV','',V.DSCOMANDAVND))) AS NRMESACOMANDA,
      DECODE('IT', 'CANCELADA', 'VENDA', DECODE(V.IDSITUVENDA, 'C', 'VENDAITEM', 'ITEM')) AS TIPO, CL.CDCLIENTE, CL.NMRAZSOCCLIE, V.IDSITUVENDA,
      L.CDLOJA,
    ";
    
    const  GET_DESIST_PROD = "
      SELECT F.CDFILIAL, V.DTVENDA, V.DTENTRVENDA, V.NRSEQVENDA, PR.CDARVPROD, PR.NMPRODUTO, F.NMFILIAL, PR.CDARVPROD || ' - ' || PR.NMPRODUTO AS LABELPRODUTO, CX.CDCAIXA || ' - ' || CX.NMCAIXA AS LABELCAIXA, 
             F.CDFILIAL || ' - ' || F.NMFILIAL AS LABELFILIAL, L.CDLOJA || ' - ' || L.NMLOJA AS LABELLOJA, ITD.CDPRODUTO, ITD.QTPRODVENDADES, PR.SGUNIDADE, NVL(V.NRNOTAFISCALCE,V.NRCUPOMFIS) AS CUPOM_NOTA,
             NVL(V.NRNOTAFISCALCE,V.NRCUPOMFIS) || ' | ' || 'Mesa/Comanda: '  || DECODE(SUBSTR(V.DSCOMANDAVND,1,3), 'PKR',V.NRMESA,DECODE(SUBSTR(V.DSCOMANDAVND,1,3),'RES',V.NRMESA,DECODE(SUBSTR(V.DSCOMANDAVND,1,3),'DLV','',V.DSCOMANDAVND))) || ' | ' || 'Operador: ' || V.CDOPERADOR || ' | ' || 'Cliente/Consumidor: ' || CL.NMRAZSOCCLIE || '/' || NVL(CO.CDCONSUMIDOR, 'Sem Consumidor') AS AGRUPADOR,
             L.NMLOJA, CX.CDCAIXA, CX.NMCAIXA, V.CDOPERADOR, OPER.NMOPERADOR, ITD.CDSUPERVISOR, SUPER.NMOPERADOR AS NMSUPERVISOR,
             (NVL(ITD.VRPRECCOMVEN,0) - (NVL(ITD.VRDESCCOMVEN,0)) + (NVL(ITD.VRACRCOMVEN,0))) AS PRECO, NVL(ITD.VRDESCCOMVEN,0) AS DESCO, NVL(ITD.VRACRCOMVEN,0) AS ACR
        FROM VENDA V
        JOIN ITVENDADES ITD
          ON V.CDFILIAL = ITD.CDFILIAL 
         AND V.CDCAIXA = ITD.CDCAIXA 
         AND V.NRSEQVENDA = ITD.NRSEQVENDA
         AND V.NRORG = ITD.NRORG
        JOIN PRODUTO PR
          ON ITD.CDPRODUTO = PR.CDPRODUTO
         AND ITD.NRORG = PR.NRORG
        JOIN FILIAL F
          ON V.CDFILIAL = F.CDFILIAL
         AND V.NRORG = F.NRORG
         AND ITD.CDFILIAL = F.CDFILIAL
         AND ITD.NRORG = F.NRORG
        JOIN LOJA L
          ON V.CDFILIAL = L.CDFILIAL
         AND V.CDLOJA  = L.CDLOJA
         AND V.NRORG = L.NRORG
         AND ITD.CDFILIAL = L.CDFILIAL
         AND ITD.NRORG = L.NRORG
        JOIN CAIXA CX 
          ON V.CDFILIAL = CX.CDFILIAL
         AND V.CDCAIXA  = CX.CDCAIXA
         AND V.NRORG = CX.NRORG
         AND ITD.CDFILIAL = CX.CDFILIAL
         AND ITD.CDCAIXA  = CX.CDCAIXA
         AND ITD.NRORG = CX.NRORG
        JOIN CLIENTE CL
          ON V.CDCLIENTE = CL.CDCLIENTE
         AND V.NRORG = CL.NRORG
        LEFT JOIN CONSUMIDOR CO 
          ON V.CDCLIENTE = CO.CDCLIENTE
         AND V.CDCONSUMIDOR = CO.CDCONSUMIDOR
         AND V.NRORG = CO.NRORG
        LEFT JOIN VENDEDOR VN
          ON V.CDVENDEDOR = VN.CDVENDEDOR
         AND V.NRORG = VN.NRORG
        LEFT JOIN OPERADOR SUPER
          ON ITD.CDSUPERVISOR = SUPER.CDOPERADOR
         AND ITD.NRORG = SUPER.NRORG
        LEFT JOIN OPERADOR OPER 
          ON V.CDOPERADOR = OPER.CDOPERADOR 
         AND V.NRORG = OPER.NRORG 
       WHERE (INSTR(:CDFILIAL, V.CDFILIAL) <> 0)
         AND V.DTENTRVENDA BETWEEN :DTINI AND :DTFIN
         AND V.NRORG = :NRORG
       ORDER BY F.CDFILIAL, L.CDLOJA, V.DTVENDA, V.NRSEQVENDA, PR.CDARVPROD
    ";
}